#include <iostream>
#include <stdlib.h>

#include "aibase.h"

AIBase::AIBase (const Player& _player, const Board& _board) : player (_player),
board (_board) { }

AIBase::~AIBase () { }

TMove AIBase::RandomStep (int cellSpread)
{
#ifndef NDEBUG
    std::cout << "AIBase: RandomStep (" << cellSpread << ')' << std::endl;
#endif // NDEBUG

    if (player.getAttackLeft () == 0)
        return NONE_MOVE;

    int row, col;

    do
    {
        row = Board::MAX_ROW / 2;
        col = Board::MAX_COL / 2;

        row += (rand () % 2 ? 1 : -1) * (rand () % cellSpread + rand () % 2);
        col += (rand () % 2 ? 1 : -1) * (rand () % cellSpread + rand () % 2);

        if (!Board::IsValidSquare (row, col) ||
                board.getCell (row, col) != EMPTY_CELL)
            continue;
        break;
    }

    while (true);

    lastMove = TCoordCell (row, col);

    return ATTACK_MOVE;
}
