/*
 * File:   aibase.h
 * Author: Vest
 *
 * Created on 25 Nov 2008 г., 21:21
 *
 * Common base class for AI
 */

#ifndef _AIBASE_H
#define	_AIBASE_H

#include "player.h"
#include "board.h"

// Movement type

enum TMove
{
    NONE_MOVE,
    BLOCK_MOVE,
    ATTACK_MOVE
};

class AIBase
{
public:
    AIBase (const Player& player, const Board& board);
    virtual ~AIBase ();

    virtual TMove Step () = 0;

    inline TCoordCell getLastMove () const
    {
        return lastMove;
    }

protected:
    const Player& player;
    const Board& board;

    TCoordCell lastMove;

    TMove RandomStep (int cellSpread = 5);
};

#endif	/* _AIBASE_H */

