/* 
 * File:   ai.h
 * Author: vest
 *
 * Created on 3 Июль 2008 г., 17:57
 */

#ifndef _AIEASY_H
#define	_AIEASY_H

#include <vector>

#include "aibase.h"

typedef std::vector<TCoordCell> TCoordCellVector;

class AIEasy : public AIBase
{
public:
    AIEasy (const Player& player, const Board& board);
    virtual ~AIEasy ();

    virtual TMove Step ();

private:
    bool firstStep;

    TCoordCellVector opponentMoves;
    TCoordCellVector playerMoves;

    TMove WinStep ();
    TMove BlockAsAttackStep ();
    TMove BlockWithBlockerStep ();
    TMove BlockWithAttackerStep ();
    TMove PlayerMoveStep ();
    TMove BlockOpponentPotential ();
    TMove StartPlayerPotential ();

    void BuildOpponentMoves ();
    void BuildPlayerMoves ();
};

#endif	/* _AIEASY_H */
