/* 
 * File:   aihard.h
 * Author: vest
 *
 * Created on 25 Nov 2008 г., 21:43
 *
 * Derrived from AIBase class, and implemented as hard AI
 */

#ifndef _AIHARD_H
#define	_AIHARD_H

#include <vector>
#include <map>

#include "aibase.h"

typedef std::map<int, int> TIntMap;

class AIHard : public AIBase
{
public:
    AIHard (const Player& player, const Board& board);
    virtual ~AIHard ();

    virtual TMove Step ();
private:
    static const int STANDARD_PRIORITY = 1;
    static const int SPOON_PRIORITY = 3;
    static const int WIN_PRIORITY = 1000;

    TIntMap playerImportant;
    TIntMap opponentImportant;

    void CheckImportant (TIntMap& important, TPlayer playerColor);
    void Pair (TIntMap& important, TPlayer playerColor,
               int row3, int col3, int row4, int col4);
    int InsertCell (TIntMap& important, int row, int col, int priority);
    TIntMap::iterator HasCritical ();
    TMove CheckOpponentAttack ();
    TMove CheckOpponentImportant ();
};

#endif	/* _AIHARD_H */
