/* 
 * File:   main.cc
 * Author: Vest
 *
 * Created on 1 Jul 2008 г., 17:45
 */

#include <gtkmm.h>
#include <librsvg/rsvg.h>
#include <stdlib.h>
#include <glibmm/i18n.h>

#include "mainwindow.h"
#include "background.h"

int main (int argc, char *argv[])
{
    bindtextdomain (GETTEXT_PACKAGE, PROGRAMNAME_LOCALEDIR);
    bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
    textdomain (GETTEXT_PACKAGE);

    Background::Clear ();
    try
    {
        Background::ScanGameDir ();
    }
    catch (const file_exception& e)
    {
        std::cerr << e.what () << std::endl;
    }

    try
    {
        Background::ScanHomeDir ();
    }
    catch (const file_exception& e)
    {
        std::cerr << e.what () << std::endl;
    }

    Gtk::Main kit (argc, argv);
    rsvg_init ();

#ifdef NDEBUG
    srand (time (0));
#endif //NDEBUG

    MainWindow window;

    Gtk::Main::run (window);
    rsvg_term ();

    return 0;
}
