/* 
 * File:   optionswindow.h
 * Author: vest
 *
 * Created on 16 Июль 2008 г., 18:11
 */

#ifndef _OPTIONSWINDOW_H
#define	_OPTIONSWINDOW_H

#include <gtkmm.h>
//#include "../libquod/player.h"
#include "types.h"
#include "options.h"

class OptionsWindow : public Gtk::Dialog
{
public:
    typedef std::list<Glib::ustring> type_listStrings;

    OptionsWindow (Gtk::Window& parent, const TOptions& options);
    virtual ~OptionsWindow ();

    virtual void GetOptions (TOptions& options) const;
    
protected:
    virtual void add_row (Gtk::Table& table, int row,
                          const Glib::RefPtr<Gtk::SizeGroup>& size_group,
                          const Glib::ustring& label_text,
                          Gtk::Widget& widget);
    virtual Gtk::ComboBoxText* create_combobox (const std::list<Glib::ustring>& strings);
    virtual void SetOptions (const TOptions& options);
    virtual void on_combo_changed ();

private:
    Gtk::Table m_optionsTable;
    Glib::RefPtr<Gtk::SizeGroup> m_refSizeGroup;

    Gtk::ComboBoxText* pm_firstCombo;
    Gtk::ComboBoxText* pm_blueCombo;
    Gtk::ComboBoxText* pm_redCombo;

    const TOptions& options;
};

#endif	/* _OPTIONSWINDOW_H */
