/* 
 * File:   playerpanel.h
 * Author: vest
 *
 * Created on 9 Июль 2008 г., 14:22
 */

#ifndef _PLAYERPANEL_H
#define	_PLAYERPANEL_H

#include <gtkmm.h>
#include <librsvg/rsvg.h>
#include <librsvg/rsvg-cairo.h>

#include "player.h"

class PlayerPanel : public Gtk::DrawingArea
{
public:
    PlayerPanel (const Player* player);
    virtual ~PlayerPanel ();
    virtual void Assign (const Player* player);

protected:
    //Override default signal handler:
    virtual bool on_expose_event (GdkEventExpose* event);

private:
    static const int MIN_WIDTH = 110;
    static const int MIN_HEIGHT = 130;

    const Player* player;

    RsvgHandle* rsvgColor;
    RsvgHandle* rsvgWhite;

    RsvgDimensionData dColor;
    RsvgDimensionData dWhite;
};

#endif	/* _PLAYERPANEL_H */

